//
//  Nome del progetto: GLScacchi
//  Titolo del gioco:  The Last Chess
//
//  Autore: Oligoatria - Giovanni Di Liberto
//  
//  Licenza:
//
//    GLScacchi, gioco di scacchi tridimensionale in OpenGL
//    Copyright (C) 2007 Giovanni Di Liberto
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License along
//    with this program; if not, write to the Free Software Foundation, Inc.,
//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
//

/*
	Non  stato un lavoro facile reimpostare il codice della Lesson10 della guida OpenGL
	di NeHe, c' voluto parecchio tempo per capire cosa convenisse fare e per correggere 
	tutti gli errori. Il codice realizzato mi sembra il pi comprensibile possibile, 
	tenendo conto che da qui in poi il progetto diverr sempre pi complicato 
																 Oligoatria - 03_01_2007

	Il progetto non si  ancora esaurito; i prossimi punti che voglio implementare sono
	la gestione delle luci, di suoni compressi, di pi suoni contemporaneamente, migliorare
	la gestione degli fps, fino ad arrivare al caricamento di modelli 3D, che comporter
	inoltre una migliore gestione delle collisioni, fino ad ora poco curate e basate su cubi.
																 Oligoatria - 02_02_2007

	Il progetto si  sviluppato ed ora si pu giocare facilmente.
	Per chi tenter di giocare senza guardare il codice, i comandi sono WASD e SPAZIO 
	per il cursore, 2 4 8 6  e  7 1  del tastierino numerico per la visuale.
	Ho voluto provare l'illuminazione, ma si tratta solo di una versione temporanea.
	Non penso che implementer i modelli 3D, soprattutto per il tempo necessario alla
	progettazione degli MD2, oltre al fatto che implementare bene luce
	e riflessi mi pare sufficiente per ottenere risultati gradevoli.
	Prossimi ToDo: - Multisuono -> non sar un problema;
	               - Correzione bug riguardanti il cursore + bug vari;
				   - Gestione delle luci;
				   - Gestione FPS;
				   - Men, Grafica iniziale, finale, sigle, dettagli vari.				   
																 Oligoatria - 22_05_2007
	P.S.: mi scuso per non avere ancora ripulito il codice.. la prossima BETA sar pi ordinata

	Finalmente ho sistemato il men dal punto di vista del codice, le visuali standard sono 
	state impostate, richiamabili tramite F1/F4; inoltre ho finito anche la modalit 2P
	(sempre senza guardare i dettagli grafici). 
	Prossimo ToDo IMPORTANTE: implementare la sfida in rete tramite l'utilizzo dei socket.
	Finito questo punto passer a curare tutti i dettagli, quindi men, sigla, suoni,
	personaggi ed effetti grafici, stage, ecc.
																 Oligoatria - 20_07_2007
	P.S.: non ho ancora ripulito il codice.. finite le vacanze ripulisco tutto, pubblico
	un'altra BETA e inserisco nel sito anche i sorgenti!

	Finalmente la parte pi pesante del progetto sta per essere conclusa! Ho appena finito
	di testare con successo il codice per la gestione delle connessioni, ora non resta che 
	utilizzare le due classi create in netProtocol per lo scambio delle mosse.
	Finito questo dovr curare tutti i dettagli grafici e sonori:
		- Progettare nuovi livelli
		- Creare diversi avversari
		- Gestire il multisuono
		- Creare le musiche di gioco
		- Sigla iniziale (o sigle)
		- Adattare il men a tutto questo (parte lunghissima)
		- Sistemare gli ultimi bug e puntarmi sugli ultimi aspetti grafici - "carineria"
		- PULIRE IL CODICE!!!
																 Oligoatria - 07_08_2007
	
	 Ci siamo, la BETA  pronta! Ho pulito il codice, non al meglio, per.
	 Ora  disponibile la modalit 2P NETWORK, ma l'ho testata solo in locale, per ora..
	 beh, pare funzioni. Sono molto soddisfatto, il grosso del codice  fatto, ora mi
	 dovr occupare di tutti quegli aspetti grafici sopra elencati + sistemare il
	 men + codice per il multisuono e per visualizzare un video. Intendo infatti
	 inserire 2 sigle: una funzionante a codice, propria del gioco, e una seconda di
	 introduzione registrata.
	 Prima cosa, per, testare il programma cos com'.
																 Oligoatria - 12_08_2007

	 Benissimo! L'illuminazione la considero conclusa, anche se non l'ho ancora affrontata
	 a livello avanzato. Il men  graficamente concluso. Ora mancano personaggi, stage
	 (ne ho aggiunto uno: "tavolino"), finire il men, suoni e musiche, sigle, rifare le
	 pedine e risolvere gli ultimi bug.. + TEST.
																 Oligoatria - 14_08_2007
	P.S.: mai mi sono ricordato, finora, di evidenziare la texture grazie alla quale 
	      ho colorato gli scacchi e ho concluso la prima scacchiera: si tratta della
		  cover del CD "Alice's Inferno" dei Forever Slave, gruppo Gothic Metal
		  (o, come dice il sito ufficiale, Female Gothic Metal Rock).
		  
	Relativo a DrawGLScene_nff:
	  Ci sono 2 tecniche geometriche per la suddivisione di poligoni in triangoli
     una pi semplice, l'altra poco pi articolata ma con un risparmio in numero di triangoli.
     ho optato per la pi semplice, in quanto il suo codice risulta decisamente pi semplice e
     sicuro, nel senso che, con il secondo metodo, se si vuole prevedere l'utilizzo di poligoni
     con oltre 16 vertici il codice inizia a diventare pi complesso (l'avevo sviluppato in
     GLWorld, ma forniva qualche difetto visivo), ed il risparmio  di 1, 2, 4 triangoli al max.
	  Stranamente il problema non  sorto per la visualizzazione delle pedine, progettate con il
	 solo utilizzo di triangoli, ma per l'aggiunta allo stage "tavolino" di alcuni cracker.

    Trovato e risolto un bug inaspettato: non chiudeva nessuno dei file txt aperti, a causa
	di un errore dovuto alla riga vuota finale di ogni file nff. Errore risolto a codice.

	Aggiunta una classe basata librerie DirectX, il cui autore  Kevin Hawkins, che gestisce
	molti aspetti degli effetti sonori, arrivando a gestire il multisuono e gli effetti
	del suono tridimensionale. Per ora utilizzo solo una minima parte delle potenzialit
	gestite	da questa libreria, anche perch un gioco di scacchi, anche se verr sicuramente
	migliorato in questo aspetto, non necessita di una componente sonora molto performante.
																 Oligoatria - 15_08_2007

	Aggiunto l'effetto esplosione! La chat  quasi finita (spero), nel men personaggi
	e scenari sono finiti, mancano lo switch delle altre opzioni e i riconoscimenti.
	Illuminazione a 3 livelli, suoni da aggiungere, siamo gi arrivati a quasi 5Mb. Tutto
	Per i suoni e per il nuovo livello tavolino, con le relative texture, poi per il men
	e i personaggi. Primi test con Jambo riguardo la modalit 2P NETWORK.
	Devo ricolorare i pezzi.
	L'apparente poca fluidit del gioco riguarda solo l'aspetto del movimento del mouse,
	per il quale ho scritto un codice non ancora buono.
	La prima stable  alle porte!
																 Oligoatria - 20_08_2007

	- Ho finito di colorare i pezzi. Ora penser alla chat, poi a finire il men.
	Solo in seguito effetti sonori. Infine gestione della vittoria. Non penso che
	per la prima stable aggiunger le condizioni di arrocco e di pedone in fondo alla
	scacchiera.
	- Ho deciso di rendere indipendente la chat, per renderla efficiente; dunque aggiunger
	2 variabili SOCKET, una per la ricezione e una per l'invio di comunicazioni. Cos non
	 neanche pi necessario inviare dei caratteri pre-stringa per identificare il messaggio
	di chat.
	- Ci messo un po', ho incasinato tutto, ho risistemato, reincasinato, risistemato,
	e cos via, ma alla fine la chat indipendente  pronta. L'unica cosa da sistemare
	 l'inserimento del testo.. un po' lento.. e mancano i caratteri speciali..
	nulla di complesso da sistemare, ma ci sono cose pi importanti, ora.
	- Ho sostituito Homer con Bob, e le foto di.. Re Denzis, ora rendono pi "anonimo"
	il personaggio. Ora penso al men e ai suoni.
																 Oligoatria - 21_08_2007
	
	La prima stable  pronta. Ci sono ancora problemi riguardo i suoni, la cui esecuzione
	richiede la presenza della DirectX 8 installata nel sistema. I bug di spostamento, 
	di selezione, di deallocazione della memoria(non completamente) sono stati risolti.
	La vittoria  gestita (malamante). Manca da fare:
	- Gestione dell'arrocco e della sostituzione di un pedone con un pezzo mangiato;
	- Sistemare il problema suoni;
	- Gestine migliore della vittoria;
	- Gestione migliore FPS;
	- Risolvere il problema di deallocazione, ora ridotto a 700kb circa
	  ad ogni chiusura del men.
	- Disegno di sfondo del men da cambiare.
	Infine si potrebbe ottimizzare il codice attraverso tecniche di grafica avanzata,
	aggiungere effetti grafici come riflessi, ombre.
	+ :  assolutamente necessario comprendere e risolvere il problema che rende, se 
	    pur poco, instabile l'applicazione.
																 Oligoatria - 21_08_2007

	- Eliminata qualche variabile inutile.
	- Aggiunta la scelta del colore delle pedine
																 Oligoatria - 28_08_2007

	Ottimo! Grazie Nikipe!!! Dopo l'ultimo test, terminato con una testata sulla 
	scrivania, ho cercato le cause dell'instabilit, a partire dal problema di 
	deallocazione. C'ho messo un po', ma ho trovato due piccoli errori di codice
	(del tipo, deallocavo la variabile sbagliata). Il problema di deallocazione
	era risolto, ma l'instabilit, da sometimes  passata a always! Non riuscivo a 
	capire, fino a quando non ho trovato un terzo errore di codice 
	(tmp++ anzich tmp->next.. che nervoso!)!!! Ora tutto pare risolto.. i prossimi
	test ci daranno la risposta.
																 Oligoatria - 29_08_2007


*/

// soluzione al conflitto tra le librerie standard:  sufficiente inserire nelle opzioni di link
// /NODEFAULTLIB:libc.lib /NODEFAULTLIB:libcmtd.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:libcd.lib /NODEFAULTLIB:msvcrtd.lib
//libcmt

// winmm.lib opengl32.lib glu32.lib glaux.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib mpr.lib wsock32.lib dxguid.lib winmm.lib

#include <winsock2.h>
#include <windows.h>		// File d'Intestazione per Windows

#include <stdio.h>			// File d'Intestazione per Standard Input/Output
#include <gl\glaux.h>		// File d'Intestazione per la libreria Glaux 

#include "GLWVideo.h"
#include "audiosystem.h"

#include "ThreadManager.h"
#include "netProtocol.h"

//#include "GameVar.h"
#include "Livello.h"


/* Classe GLWVideo */
	GLWVideo *Screen;			// svolge le operazioni principali che richiamano l'OpenGL

/* Variabili chiave dell'applicazione */
	HDC			hDC=NULL;		// Device Context GDI privato
	HGLRC		hRC=NULL;		// Rendering Context permanente
	HWND		hWnd=NULL;		// Handle alla Finestra 
	HINSTANCE	hInstance;		// Istanza dell'Applicazione

	bool	keys[256];			// Array usato per la routine della tastiera
	bool	active=TRUE;		// Flag di Finestra Attiva, settato a TRUE di default

/* costanti comode in fase di sviluppo, ma che non dovranno esserci nella stable */
	int ral = 25;
	int SCREEN_X     = 1024;
	int SCREEN_Y     = 768;
	int SCREEN_BITS  = 16;
//	bool screen_dinamico=false;

/* visuale */
	GLfloat lookupdown;
	GLfloat	yrot;
	float	heading;
	unsigned short int DirezioneComandi;	    // se 1 si vede dai bianchi, 2 dal punto di vista dei neri, 3 e 4 visuali laterali
	
/* prototipo metodi globali */
//	extern void FPS(); // Calcolo le fps
//	extern int GetFPS (void);									// Returns The FPS If Called Every Frame
	extern void InitGameVar();
	LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Prototipo di funzione per WndProc // gestisce le chiamate di sistema

/* rete */
//	extern bool sonoServer;


int WINAPI WinMain(	HINSTANCE	hInstance,			// Istanza
					HINSTANCE	hPrevInstance,		// Istanza precedente
					LPSTR		lpCmdLine,			// Parametri della linea di comando
					int			nCmdShow)			// Stato di display della Finestra (Show State)
{	
	/* Inizializzo le variabili di gioco */
		InitGameVar();

	/* Creo l'oggetto principale della visualizzazione video */
		Screen = new GLWVideo(ral, SCREEN_X, SCREEN_Y, SCREEN_BITS);
	
	/* HELP TEMPORANEO: COMANDI */
		MessageBox(NULL,"*** THE LAST CHESS ***\nATTENZIONE: GESTISCO I SUONI SFRUTTANDO LA DIRECTX 8, non so ancora cosa accadr con versioni differenti.\n\nORA E' POSSIBILE GIOCARE CONTRO IL COMPUTER IN 2 SULLO STESSO PC O IN RETE\n\nI COMANDI DI GIOCO SONO I SEGUENTI:\n[w] [a] [s] [d] [SPAZIO] --> per selezionare, nel men e nel gioco\n[4] [8] [6] [2] [1] [7] [MOUSE] --> per spostare la visuale\n[F1] [F2] [F3] [F4] --> per le visuali predefinite\n[v] --> per abilitare il mouse per la visuale in prima persona\n\nNel men client, per velocizzare la selezione dell'indirizzo IP, premere [a] oppure [d] e contemporaneamente [SPAZIO].\nPremere c durante la modalit 2PNET per poter comunicare tramite chat (ha ancora alcuni bug da risolvere)\n\nOligoatria", "HELP TEMPORANEO",MB_OK);

	/* Chiede utente se vuole il fullscreen */
		if (MessageBox(NULL,"Schermo intero?", "Schermo intero?",MB_YESNO|MB_ICONQUESTION)==IDNO)
		{
			Screen->fullscreen=FALSE;							// Modalit finestra
		}	

	/* Variabili del ciclo di gioco */			
		MSG		msg;									// Struttura Windows Message 
		BOOL	done=FALSE;								// Variabile Bool per uscire dal ciclo
		int SCELTA=0;
			
	/* Inizializzo il mondo 3D */
		if (!Screen->InitWorld("The Last Chess"))
			return 0;

	/* Inizializzo i COM (Component Object Model), necessario per utilizzare la DirectX */
		CoInitialize(NULL);

	/* Inizializzo gli AudioSystem, 1-sottofondo, 2-effetti sonori generici, 3-esplosioni */
		CAudioSystem *audioSystem[3];
		
		audioSystem[0] = new CAudioSystem;
		audioSystem[0]->InitDirectXAudio(NULL);

		audioSystem[1] = new CAudioSystem;
		audioSystem[1]->InitDirectXAudio(NULL);

		audioSystem[2] = new CAudioSystem;
		audioSystem[2]->InitDirectXAudio(NULL);

		
	/* Sigla Oligoatria */
		
	/* Sigla "The Last Chess" */
		Sigla1(Screen, audioSystem);
	/* Men */
		while (SCELTA!=-1)
		{				
			SCELTA=Menu(Screen, audioSystem);

			InitGameVar();       // inizializzo le variabili di gioco (mi interessano quele del cursore)
			if (SCELTA==1)       // 1P
			{
				if (MessageBox(NULL,"Vuoi i bianchi?", "Scelta pedine",MB_YESNO|MB_ICONQUESTION)==IDNO)
					SCELTA=Livello(Screen,  1, FALSE, audioSystem);
				else
					SCELTA=Livello(Screen,  1, TRUE, audioSystem);
			}
			else if (SCELTA==2)  // 2P
				SCELTA=Livello(Screen, -1, TRUE, audioSystem);
			else if (SCELTA==3)  // 2P NET SERVER		
				SCELTA=Livello(Screen, -2, TRUE, audioSystem);   // -2 == io sono il server
			else if (SCELTA==4)  // 2P NET CLIENT			
				SCELTA=Livello(Screen, -3, FALSE, audioSystem);  // -3 == io sono il client
			else if (SCELTA==19) // SIGLA
				Sigla1(Screen, audioSystem);
		}

	/* Chiusura */
		audioSystem[0]->Shutdown();
		delete audioSystem[0];
		audioSystem[1]->Shutdown();
		delete audioSystem[1];
		audioSystem[2]->Shutdown();
		delete audioSystem[2];
		Screen->KillGLWindow();							// Distrugge la Finestra
		delete Screen;                                  // dealloca la variabile Screen

		CoUninitialize();

	return (msg.wParam);							// Esce dal programma
}

//
 // 

// 

void Mouse_move()
{
	POINT mousePos;	
	int mid_x = SCREEN_X  >> 1;	
	int mid_y = SCREEN_Y  >> 1;	
	float angle_y  = 0.0f;				
	float angle_z  = 0.0f;							
	
	GetCursorPos(&mousePos);					
	SetCursorPos(mid_x, mid_y);	// mouse impostato al centro dello schermo

	// calcolo quanto  stato mosso il mouse
	angle_y = (float)( (mid_x - mousePos.x) ) / 1000;		
	angle_z = (float)( (mid_y - mousePos.y) ) / 1000;

	if (((lookupdown-angle_z*100)<40)&&((lookupdown-angle_z*100)>-40))
		lookupdown+=-angle_z*100;

	yrot+=angle_y*100;				
	heading=yrot;	
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle per questa Finestra
									UINT	uMsg,			// Messaggio per questa Finesta
									WPARAM	wParam,			// Ulteriori Informazioni sul messaggio
									LPARAM	lParam)			// Ulteriori Informazioni sul messaggio
							
{
	switch (uMsg)									// Testa i messaggi di Windows 
	{
		case WM_ACTIVATE:							// Tratta il messaggio di attivazione finestra 
		{
			if (!HIWORD(wParam))					// Testa per lo stato di riduzione a icona
			{
				active=TRUE;						// Il programma  attivo
			}
			else
			{
				active=FALSE;						// Il programma non  attivo
			}

			return 0;								// Ritorna al ciclo dei messaggi 
		}

		case WM_SYSCOMMAND:							// Intercetta i comandi di sistema
		{
			switch (wParam)							// Testa per chiamate di sistema
			{
				case SC_SCREENSAVE:					// Il salvaschermo sta provando a partire?
				case SC_MONITORPOWER:				// Il Monitor sta provando ad andare in stand-by?
				return 0;							// Evita gli eventi
			}
			break;									// Esci
		}

		case WM_CLOSE:								// E' stato ricevuto un messaggio di chiusura?
		{
			PostQuitMessage(0);						// Manda un messaggio Quit (chiudi)
			return 0;								// Ritorna
		}

		case WM_KEYDOWN:							// E' stato premuto un tasto?
		{
			keys[wParam] = TRUE;					// Se si, lo marca a TRUE
			return 0;								// Ritorna
		}

		case WM_KEYUP:								// E' stato rilasciato un tasto?
		{
			keys[wParam] = FALSE;					// Se si, lo marca a FALSE
			return 0;								// Ritorna
		}

		/*case WM_SIZE:			// Ridimensiona la Finestra OpenGL - eliminato per evitare difetti visivi da sistemare
		{		
		/*	if (screen_dinamico)*/
		//		Screen->ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Larghezza, HiWord=Altezza			
		/*	return 0;								// Ritorna
		}*/
	}

	// Passa tutti i messaggi non gestiti a DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}
