#ifndef LIVELLO_H
#define LIVELLO_H

#include "gestioneFPS.h"
//#include "GameVar.h"

extern bool	keys[256];    // Array usato per la routine della tastiera

/* Oggetti aggiuntivi */
	#define SCELTA1 1   // oggetto cubo di scelta
	#define SCELTA2 4
	#define SIGLA1  2
	#define SIGLA2  3
    #define OLI     5
    #define GOATRIA 6
	#define SOFT    7

/* Comandi men */
	#define MENU_ERROR     0  // se la lista di comandi  vuota
	#define MENU_SERVER    1
	#define MENU_CLIENT    2
	#define MENU_OK        3
	#define MENU_INDIETRO -1
	#define MENU_INDIETRO_OPT -8
	#define MENU_VAI_MENU -2
	#define MENU_ESCI     -3
	#define MENU_IP_0     -4
	#define MENU_IP_1     -5
	#define MENU_IP_2     -6
	#define MENU_IP_3     -7
	#define MENU_NULL    -10
	#define MENU_LUCI           4
	#define MENU_MUSICHE        5 
	#define MENU_EFFETTI_SONORI 6
	#define MENU_RISOLUZIONE    7
	#define MENU_BIT_RATE       8
	#define MENU_FULL_SCREEN    9
	#define MENU_MODE_VISUALE  10
	#define MENU_CHAT          11

	#define MENU_STAGE        100
	#define MENU_STAGE1       101
	#define MENU_STAGE2       102
	#define MENU_STAGE3       103
	#define MENU_STAGE4       104
	#define MENU_STAGE5       105

	#define MENU_AVVERSARIO   200
	#define MENU_AVVERSARIO1  201
	#define MENU_AVVERSARIO2  202
	#define MENU_AVVERSARIO3  203
	#define MENU_AVVERSARIO4  204
	#define MENU_AVVERSARIO5  205

/* Scenari */
	#define STAGE_DESERTO "data/stages/world_deserto.nff"
      #define MENU_STAGE_DESERTO  "DESERT"
	#define STAGE_TAVOLINO "data/stages/world_tavolo.nff"
      #define MENU_STAGE_TAVOLINO "CHESS ROOM"

/* Avversari */
	#define AVVERSARIO1 "ReDenzis"
		#define AVVERSARIO_LIVELLO1 3
	#define AVVERSARIO2 "Bob"
		#define AVVERSARIO_LIVELLO2 1



void Sigla1(GLWVideo *Screen, CAudioSystem **audioSystem);
int Menu(GLWVideo *Screen, CAudioSystem **audioSystem);
int Livello(GLWVideo *Screen, short int Avversario, bool ColBianco, CAudioSystem **audioSystem);

/* Funzioni di men */
	void MenuOpzioni(GLWVideo *Screen);
	void MenuStage(GLWVideo *Screen);
	void MenuClient(GLWVideo *Screen);
	void MenuGiocoPrincipale(GLWVideo *Screen, short Avversario);
	void Menu2PNET(GLWVideo *Screen);
	void MenuAvversari(GLWVideo *Screen);
	void MenuRiconoscimenti(GLWVideo *Screen);

#endif /* LIVELLO_H */
