// netProtocol.h: header file del protocollo per la comunicazione di rete tramite socket
// by Oligoatria
// 
// LE CLASSI SVILUPPATE PRENDONO LE LORO FONDAMENTA DAL SERVER_PROTOCOL DI
// BEATRIX, PROGETTO DI PIEROTOFY E NETARROW, SCARICABILE DA PIEROTOFY.IT. 
//
// GRAZIE ANCHE A mamo139, Utente di HTML.it  
//              http://forum.html.it/forum/showthread.php?threadid=975345
//
// N.B.: aggiungere alle librerie da linkare mpr.lib e wsock32.lib
//
////////////////////////////////////////////////////////////////////////////////////////

#ifndef NETPROTOCOL_H
#define NETPROTOCOL_H

#define SERVER_SOCKET_ERROR 1
#define SERVER_SOCKET_OK 0
#define BUFFER_LENGTH 256

struct BUF_SOCKET
{
	SOCKET *s;
	char *buffer;
};

static void WaitForClientConnection(SOCKET *s);     // Ritorna un oggetto SOCKET alla prima connessione di un client			
static int RecvFrom(BUF_SOCKET *bs);

extern bool in_connessione;

class cNetProtocol
{
	public:
		/* Funzioni di inizializzazione del socket */
			SOCKET OpenServer(int iPort);                 // Apre il server su una porta e ritorna un riferimento al socket
			SOCKET AspettaUnClient(SOCKET *s, int ID);             // funzione da richiamare					
		
		/* Funzioni di comunicazione */
			void RiceviDa(BUF_SOCKET *bs, unsigned int ID);        // Funzione per ricevere un messaggio dalla socket
			int SendTo(SOCKET s, char *pText);           // Funzione per inviare un messaggio alla socket
		
		/* Funzioni di inizializzazione del socket client */
			SOCKET InitClientSocket(unsigned int *iIndirizzo, int iPort, const char *nome_socket);
	
			SOCKET client, Invio, Ricevo;
						
		/* Gestione dei thread */
			cThreadManager ThreadManager;
};



#endif /* NETPROTOCOL_H */